'use strict';

var rollupPluginutils = require('rollup-pluginutils');
var jsonlint$1 = require('@prantlf/jsonlint');

function jsonlint ({
  include, exclude, preferConst, compact, namedExports, indent = '\t',
  mode, ignoreBOM, ignoreComments, ignoreTrailingCommas,
  allowSingleQuotedStrings, allowDuplicateObjectKeys
} = {}) {
  const filter = rollupPluginutils.createFilter(include, exclude);  

  return {
    name: 'jsonlint',

    transform (code, id) {
      if (!(id.endsWith('.json') && filter(id))) return null

      // try {
      const data = jsonlint$1.parse(code, {
        mode, ignoreBOM, ignoreComments, ignoreTrailingCommas,
        allowSingleQuotedStrings, allowDuplicateObjectKeys
      });

      return {
        code: rollupPluginutils.dataToEsm(data, { preferConst, compact, namedExports, indent }),
        map: { mappings: '' }
      }
      // } catch (err) {
      //   /* c8 ignore next 2 */
      //   const message = err.reason ?? err.message
      //   const position = err?.location?.start?.offset ?? 1
      //   this.warn({ message, id, position })
      //   return null
      // }
    }
  }
}

module.exports = jsonlint;
//# sourceMappingURL=index.cjs.map
